function f=gauss(m,sq,x)
f=exp((-(x-ones(x)*m)^2)./(2*sq))/sqrt(2*%pi*sq)
endfunction

function z=discr(p,n)
x=rand(1,n);
z=zeros(x);
q=cumsum(p);
q=[0,q];
for i=1:length(q)-1;
  l=((x>q(i)) & (x<q(i+1)));
  z(l)=i;   
end;
endfunction


function X=echantillon(n,p,m,v)
z=discr(p,n)
X=grand(1,n,"nor",0,1)
X=sqrt(v(z)).*X+m(z)
endfunction


function em(alv,muv,sqv,n,iter)
k=length(alv)
X=echantillon(n,alv,muv,sqv)
ec=X
al=ones(1,k)/k
mu=[1:k]
sq=ones(1,k)
h=zeros(n,k)
xbasc()
histplot(30,ec,3)
for i=1:iter
//etape Expectation
  for l=1:k
      h(:,l)=(al(l)*gauss(mu(l),sq(l),X))'
  end 
  sumc=sum(h,'c')
  for l=1:k
     h(:,l)=h(:,l)./sumc
  end
//etape Minimisation
  s=sum(h,'r')
  al=s/n
  for l=1:k
    mu(l)=(X*h(:,l))/s(l)
    sq(l)=(((X-mu(l)*ones(1,n)).^2)*h(:,l))/s(l)
  end
end
// Comparaison des paramètres
disp('al vrai')
disp(alv)
disp('al estimé')
disp(al)
disp('mu vrai')
disp(muv)
disp('mu estimé')
disp(mu)
disp('variance vraie')
disp(sqv)
disp('variance estimée')
disp(sq)

// Tracé des deux densités
X=[min(muv)-5:.01:max(muv)+5]
Y=zeros(X)
Z=zeros(X)
for l=1:k
  Y=Y+al(l)*gauss(mu(l),sq(l),X)
  Z=Z+alv(l)*gauss(muv(l),sqv(l),X)
end
plot2d(X,Y,5)
plot2d(X,Z,2)
legends(['Densite vraie','Estimation','Histogramme'],[2,5,3],1)
//xtitle('Algorithme EM')
endfunction

