clear; 
N = 100; u = .05; v = .05; P = zeros(N+1,N+1); 
init = floor(N/2); tmax = 100; nsamples = 10000;
// Transition matrix
for x=0:N,
 P(1+x,:) = binomial((x*(1-u)+(N-x)*v)/N,N);
end
// Invariant measure
// [M,Q] = eigenmarkov(P); // seems to be bugged in Scilab 5.5
[R,D] = spec(P');
for j=1:N+1 
  if (abs(D(j,j)-1)<10E-10) then mu = R(:,j); break; end 
  end
mu = abs(mu); mu = mu / sum(mu);
// check if good invariant probability
disp(max(P'*mu-mu))

// Samples (MCMC)
samples = grand(1,"markov",P^tmax,ones(1,nsamples)*init);

// Plots
clf()
plot2d(mu)
histplot(floor(3*log(nsamples)),samples)
h = gca();
h.children.children.thickness=2;
xs2pdf(gcf(),'fisherwrightmutation') //, 'landscape');

 
