///////////////////////////////////////////////////////////////////
function traj(a,s,t,n)
tc=t^2;sc=s^2;
V=t*rand(1,n+1,'n');
W=s*rand(1,n+1,'n');
///// Initialisations /////
X=W(1)*ones(1,n+1);
Y=zeros(1,n+1);Y(1)=X(1)+V(1);
P=zeros(1,n+1); P(1)=tc*sc/(sc+tc);
Xc=zeros(1,n+1); Xc(1)=P(1)*Y(1);
////// Rcurrence  /////////
for k=1:n
  X(k+1)=a*X(k)+W(k);
  Y(k+1)=X(k+1)+V(k+1);
  P(k+1)=(tc*a^2*P(k)+tc*sc)/(a^2*P(k)+sc+tc);
  Xc(k+1)=a*Xc(k)+P(k+1)*(Y(k+1)-a*Xc(k))/tc;
end;
//// Affichage //////
xbasc();
plot2d([0:n],X,3);
plot2d([0:n],Xc,5);
plot2d([0:n],Y,2);
legends(['signal','filtre','Y'],[3,5,2],2);
xtitle('Filtre de Kalman-Bucy avec a='+string(a)+', sigma='+string(s)+' et tau='+string(t));
endfunction


///////////////////////////////////////////////////////////////////
function P(a,s,t,n)
tc=t^2;sc=s^2;
P=zeros(1,n+1); P(1)=tc*sc/(sc+tc);
for k=1:n
  P(k+1)=(tc*a^2*P(k)+tc*sc)/(a^2*P(k)+sc+tc);
end;
Pinf=(sqrt((sc+tc*(1-a^2))^2+4*a^2*tc*sc)-sc-tc*(1-a^2))/(2*a^2);
xbasc()
plot2d([0:n],P,2);
plot2d([0,n],[Pinf,Pinf],3);
plot2d([0,n],[tc,tc],5);
legends(['P','P limite','tau^2'],[2,3,5],2);
xtitle('Variance de Xchapeau et de Y avec sigma='+string(s)+' et tau='+string(t));
endfunction

/////////////////////////////////////////////////////////////////:
function esti(a,s,t,n)
tc=t^2;sc=s^2;
V=t*rand(1,n+1,'n');
W=s*rand(1,n+1,'n');
///// Initialisations /////
X=W(1)*ones(1,n+1);
Y=zeros(1,n+1);Y(1)=X(1)+V(1);
P=zeros(1,n+1); P(1)=tc*sc/(sc+tc);
Xc=zeros(1,n+1); Xc(1)=P(1)*Y(1);
////// Rcurrence Trajectoire/Observation/Filtre /////////
for k=1:n
  X(k+1)=a*X(k)+W(k);
  Y(k+1)=X(k+1)+V(k+1);
  P(k+1)=(tc*a^2*P(k)+tc*sc)/(a^2*P(k)+sc+tc);
  Xc(k+1)=a*Xc(k)+P(k+1)*(Y(k+1)-a*Xc(k))/tc;
end;
////////  Estimation de a ////////////////////////////////
ac=cumsum(X(1:n).*X(2:n+1))./cumsum(X(1:n).^2)
acc=cumsum(Xc(1:n).*Xc(2:n+1))./cumsum(Xc(1:n).^2)
xset("window",0)
xbasc()
plot2d([1:n],ac,5)
plot2d([1:n],acc,3)
plot2d([1,n],[a,a],2)
legends(['a','achap','achapchap'],[2,5,3],1)
////////  Estimation de s^2 ////////////////////////////////
vc=zeros(1,n)
vcc=zeros(1,n)
for k=1:n
  vc(k)=mean((X(2:k+1)-ac(k)*X(1:k)).^2)
  vcc(k)=mean((Xc(2:k+1)-acc(k)*Xc(1:k)).^2)
end
xset("window",1)
xbasc()
plot2d([1:n],vc,5)
plot2d([1:n],vcc,3)
plot2d([1,n],[sc,sc],2)
legends(['s^2','s^2chap','s^2chapchap'],[2,5,3],1)


