## From Julia you may load it using include("polya.jl")
a = 1 # nombre initial de boules argentées
b = 1 # nombre initial de boules blanches
T = 100 # temps maximal pour les trajectoires
##
Pkg.add("Gadfly") # produces "INFO: Nothing to be done." if already installed.
Pkg.add("Cairo") # produces "INFO: Nothing to be done." if already installed.
using Gadfly
using Cairo
#
M = zeros(N,1+T)
for n = 1:4 # 4 trajectoires à tracer
    M[n,1] = a/(a+b)
    for t = 0:T-1
        M[n,2+t] = ((a+b+t)*M[n,1+t] + (rand() < M[n,1+t]))/(a+b+t+1)
    end
end

p = plot(layer(x = [0:T], y = M[1,:], Geom.line),
         layer(x = [0:T], y = M[2,:], Geom.line),
         layer(x = [0:T], y = M[3,:], Geom.line),
         layer(x = [0:T], y = M[4,:], Geom.line), 
         Guide.xlabel("n"), 
         Guide.ylabel("Mn"), 
         Theme(default_color=color("black")),
         Guide.title(@sprintf("Urne de Polya, a=%i, b=%i",a,b)))
#draw(PNG("polya.png", 10cm, 10cm), p)
draw(PDF("polya.pdf", 10cm, 10cm), p)
