## From Julia you may load it using include("prefatta.jl")
n = 20 # nombre de sites du graphe à simuler
##
Pkg.add("Graphs") # produces "INFO: Nothing to be done." if already installed.
Pkg.add("GraphLayout") # idem.
#
function random_discrete(p)
    u = rand()
    q = cumsum(p)
    for k = 1:length(p)
        if u <= q[k]
            return k
        end
    end
end
         
#
using Graphs
w = zeros(n)
g = simple_graph(n, is_directed=false)
add_edge!(g, 1, 2)
w[1] = 3
w[2] = 1
for k = 3:n
    p = w[1:k-1]/sum(w[1:k-1])
    println(p)
    j = random_discrete(p)
    add_edge!(g,k,j)
    w[j] += 1
    w[k] = 1
end

using GraphLayout
a = adjacency_matrix(g)
locs_x,locs_y = layout_spring_adj(a)
draw_layout_adj(a, locs_x, locs_y, labels = map(string,[1:n]), filename="prefatta.svg") 


