## From Julia you may load it using include("reinfowalk.jl")
r = 1.1 # coefficient de renforcement géométrique
a = 1 # valeur initiale phéromone pour chemin a
b = 1 # valeur initiale phéromone pour chemin b
T = 300 # temps maximal pour les trajectoires
##
Pkg.add("Gadfly") # produces "INFO: Nothing to be done." if already installed.
Pkg.add("Cairo") # produces "INFO: Nothing to be done." if already installed.
using Gadfly
using Cairo
#
A = zeros(N,1+T)
B = zeros(N,1+T)
X = zeros(N,1+T)
for n = 1:4 # 4 trajectoires à tracer
    A[n,1] = a
    B[n,1] = b
    for t = 0:T-1
        if rand() > A[n,1+t]/(A[n,1+t]+B[n,1+t])
            X[n,2+t] = 0 # code pour b
            A[n,2+t] = A[n,1+t]
            B[n,2+t] = r*B[n,1+t]
        else
            X[n,2+t] = 1 # code pour a
            A[n,2+t] = r*A[n,1+t]
            B[n,2+t] = B[n,1+t]
        end
    end
end

p = plot(layer(x = [1:T], y = cumsum(X[1,2:end]'.==1)./[1:T], Geom.line),
         layer(x = [1:T], y = cumsum(X[2,2:end]'.==1)./[1:T], Geom.line),
         layer(x = [1:T], y = cumsum(X[3,2:end]'.==1)./[1:T], Geom.line),
         layer(x = [1:T], y = cumsum(X[4,2:end]'.==1)./[1:T], Geom.line), 
         Guide.xlabel("n"), 
         Guide.ylabel("San/n"), 
         Theme(default_color=color("black")),
         Guide.title("Marches renforcées géométriquement."))
draw(PDF("reinfowalk.pdf", 10cm, 10cm), p)
