## From Julia you may load it using include("tsp.jl")
n = 10 # nombre de villes
tmax = 100000 # nombre maximal d'itérations
## villes randomisées sur C
pos = rand(n)+rand(n)*im 
config = [1:n]
## villes bien réparties le long du cercle
#pos = exp([0:n-1]*2*pi*im/n) # villes le long du cercle 
#config = shuffle([1:n])

function transposition(conf)
    i = ceil(n*rand())
    j = ceil((n-1)*rand())
    if j>=i then
        j += 1
    end
    conf[i],conf[j] = conf[j],conf[i]
end

function longueur(conf)
    p = pos[conf]
    w = [p[2:n]-p[1:n-1],p[n]-p[1]]
    return sqrt(real(sum(w.*conj(w)))) 
end

Pkg.add("Gadfly") # produces "INFO: Nothing to be done." if already installed.
Pkg.add("Cairo") # produces "INFO: Nothing to be done." if already installed.
using Gadfly
using Cairo
time = 0
value = longueur(config)
bestconfig = config
bestvalue = value
besttime = time
times = [time]
values = [value]
i = 0
while (time < tmax)
    if value < bestvalue
        println(time," ",value)
        values = [values , value]
        times = [times, time]
        bestconfig = config
        bestvalue = value
        besttime = time
        points = pos[bestconfig]
        points = [points;points[1]]
        p = plot(x = real(points), y = imag(points), 
                 Geom.point, 
                 Geom.path(), 
                 Theme(default_color=color("black")),
       	         #Guide.title("Tournée optimale")
                 )
        draw(PNG(@sprintf("tsp2-%d.png",i), 10cm, 10cm), p)
        i += 1
    end
    transposition(config)
    value = longueur(config)
    time += 1
end
p = plot(x = times, y = values, 
         Geom.line, 
         Guide.xlabel("Temps"), 
         Guide.ylabel("Longueur de la  tournée"), 
         Theme(default_color=color("black")),
         Guide.title(@sprintf("Recuit simulé voyageur de commerce n=%d",n)))
draw(PNG("tsp1.png", 10cm, 10cm), p)
