## From Julia you may load it using include("tsp.jl")
n = 200 # nombre de villes
tmax = 10000 # nombre maximal d'itérations
m = 1000 # nombre de configurations randomisées
nn = n # pour que les fonctions comprennent que la variable globale existe.

function transposition(conf)
    i,j = ceil([nn,nn-1].*rand(2))
    if j>=i; j += 1 end
    conf[i],conf[j] = conf[j],conf[i]
end

function longueur(pos,conf)
    p = pos[conf]
    w = [p[2:nn]-p[1:nn-1],p[nn]-p[1]]
    return sqrt(real(sum(w.*conj(w)))) 
end


Pkg.add("Gadfly") # produces "INFO: Nothing to be done." if already installed.
Pkg.add("Cairo") # produces "INFO: Nothing to be done." if already installed.
using Gadfly
using Cairo

bestvalues = zeros(n,m)
for nn=2:n
    for mm=1:m
        ## villes randomisées sur le carré [0,1]^2 de C=R^2
        positions = rand(nn)+rand(nn)*im        
        config = [1:nn]
        time = 0
        value = longueur(positions,config)
        bestconfig = config
        bestvalue = value
        besttime = time
        times = [time]
        values = [value]
        i = 0
        while (time < tmax)
            if value < bestvalue
                #println(time," ",value)
                values = [values , value]
                times = [times, time]
                bestconfig = config
                bestvalue = value
                besttime = time
                # points = positions[bestconfig]
                # points = [points;points[1]]
                # p = plot(x = real(points), y = imag(points), 
                #          Geom.point, 
                #          Geom.path(), 
                #          #Guide.title("Tournée optimale")
                #         )
                # draw(PNG(@sprintf("tsp2-%d.png",i), 10cm, 10cm), p)
                i += 1
        end
            transposition(config)
            value = longueur(positions,config)
            time += 1
        end # while
        bestvalues[nn,mm] = bestvalue
        # p = plot(x = times, y = values, 
        #          Geom.line, 
        #          Guide.xlabel("Temps"), 
        #          Guide.ylabel("Longueur de la  tournée"), 
        #          Guide.title(@sprintf("Recuit simulé voyageur de commerce n=%d",n)))
        # draw(PNG("tsp1.png", 10cm, 10cm), p)
    end # for
end # for

p = plot(x = [1:n], y = mean(bestvalues,2)./sqrt([1:n]),
         Geom.line,
         Guide.xlabel(""),
         Guide.ylabel(""),
         #Guide.title("TSP"),
         Theme(default_color=color("black")))
draw(PNG("tsprand.png", 10cm, 10cm),p)

#EOF
