//ce programme simule les configurations successives de la chane de markov cyclique  tps discret
function [R]= sim(N,n)
u=rand(1,N);
X=0*(u<0.5)+1*(u>0.5);
R=[X];

for j=1:n
c=zeros(1,N);

		for i=2:N-1 
			if X(i)==1 then c(i)=(1-X(i-1))+(1-X(i+1));
			else c(i)=X(i-1)+X(i+1);
			end;
		end;
	
		if X(1)==1 then c(1)=(1-X(N))+(1-X(2));
		else c(1)=X(N)+X(2);
		end;
	
		if X(N)==1 then c(N)=(1-X(N-1))+(1-X(1));
		else c(N)=X(N-1)+X(1);
		end;
	
	v=sum(c);
	l=zeros(1,N);
		if v>0 then 
			for k=1:N 
			l(k)=sum(c(1:k))/v;
			end;
		r=rand(1.1);k=1;
			while l(k)<r do k=k+1;
			end;
		X(k)=1-X(k);
		R=[R;X];
		else R=[R]
		end;
end;
//on constate que le nombre de composantes connexes semble tre une fonction dcroissante du tps
//(ce qui est effectivement vrai) 
//De plus les configurations (0,..,0) et (1,..,1) sont des tats absorbants.
//les autres tant transitoires




//_______________________________________________________________________________________________

//ce programme permet d'illustrer la convergence vers les mesures de dirac en les configurations
// (0,,..,0) et (1,..,1) ainsi que leur probabilit

function []= simcyc(N,n,m)

p=0;q=[];
for t=1:m

	u=rand(1,N);
        X=[zeros(1,N/2),ones(1,N/2)];
//	X=0*(u<0.5)+1*(u>0.5);
	R=[X];



	for j=1:n
	c=zeros(1,N);

		for i=2:N-1 
			if X(i)==1 then c(i)=(1-X(i-1))+(1-X(i+1));
			else c(i)=X(i-1)+X(i+1);
			end;
		end;
	
		if X(1)==1 then c(1)=(1-X(N))+(1-X(2));
		else c(1)=X(N)+X(2);
		end;
	
		if X(N)==1 then c(N)=(1-X(N-1))+(1-X(1));
		else c(N)=X(N-1)+X(1);
		end;
	
	v=sum(c);
	l=zeros(1,N);
		if v>0 then 
			for k=1:N 
			l(k)=sum(c(1:k))/v;
			end;
		r=rand(1.1);k=1;
			while l(k)<r do k=k+1;
			end;
		X(k)=1-X(k);
		R=[R;X];
		else R=[R]
		end;
	end;
	
[g,h]=size(R);
s=sum(R(g,:));

	if s==0 then p=p+1;
	end;
	
q=[q p/t];
end;	

P=p/m;	
xbasc()
plot2d([1:m],q([1:m]))
plot2d([1:m],(1/2)*ones(1,m),4);
disp('proba pour que la chane converge vers la mesure de dirac en 0 : '+string([P]))


//___________________________________________________________________________________________________
//___________________________________________________________________________________________________

//on passe au modle avec conditions aux bords

//ce programme simule les configurations successives de la chane de markov avec conditions aux bords  tps discret
function [R]= simbor(N,n)
u=rand(1,N);
X=[0,0*(u<0.5)+1*(u>0.5),1];
R=[X];

for j=1:n
c=zeros(1,N+2);

		for i=2:N+1 
			if X(i)==1 then c(i)=(1-X(i-1))+(1-X(i+1));
			else c(i)=X(i-1)+X(i+1);
			end;
		end;
			
	v=sum(c);
	l=zeros(1,N+2);
		if v>0 then 
			for k=1:N+2 
			l(k)=sum(c(1:k))/v;
			end;
		r=rand(1.1);k=1;
			while l(k)<r do k=k+1;
			end;
		X(k)=1-X(k);
		R=[R;X];
		else R=[R]
		end;
end;
//on peut dj remarquer que le nombre de composantes connexes est une fonction dcroissante du tps
//il y a au moins 2 composantes connexes
// tous les tats  2 composantes connexes sont rcurrents, les autres sont transitoires




//_______________________________________________________________________________________________

//matrice de transition de la nouvelle chane de markov
//et l'on gnre la suite : Yn=max{x ds S tq Xn(x)=0}

function [Y,P]=markov(N,n,Y0)
P=zeros(N+1,N+1);
for i=2:N
    P(i,i-1)=1/2
    P(i,i+1)=1/2
end;
P(1,2)=1;
P(N+1,N)=1;

Y=grand(n,'markov',P,Y0);

//_______________________________________________________________________________________________

//convergence vers la mesure invariante

function [S]=mesinv(N,n,k)
P=zeros(N+1,N+1);
for i=2:N
    P(i,i-1)=1/2
    P(i,i+1)=1/2
end;
P(1,2)=1;
P(N+1,N)=1;


Q=P^(2*n+1)
R=P^(2*n)
S=R(1,:)/2+Q(1,:)/2;
M=[];
for i=1:n
	Q=P^(2*i+1)
	R=P^(2*i)
	S=R(1,:)/2+Q(1,:)/2;
	M=[M;S]
 end;

xbasc()
xset("font size",2)

xsetech([0 0 0.5 0.5])
plot2d([1:n],M([1:n],1),4)
plot2d([1:n],(1/(2*N))*ones(1,n),2)
plot2d([1:n],0*ones(1,n),2)
xtitle('convergence vers 0=1/2N')

xsetech([0.5 0 0.5 0.5])
plot2d([1:n],M([1:n],k),4)
plot2d([1:n],(1/(N))*ones(1,n),2)
plot2d([1:n],0*ones(1,n),2)
xtitle('convergence vers k=1/N')

xsetech([0 0.5 0.5 0.5])
plot2d([1:n],M([1:n],N+1),4)
plot2d([1:n],(1/(2*N))*ones(1,n),2)
plot2d([1:n],0*ones(1,n),2)
xtitle('convergence vers N=1/2N')

xsetech([0.5 0.5 0.5 0.5])
xset("font size",4)
legends(['mesure thorique','mesure exprimentale'],[2,4],2)

